<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    
<title>Moodle Docs: Basic Installation</title>
  
<link rel="stylesheet" href="docstyles.css" type="TEXT/CSS" />
    
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<style type="text/css">
<!--
.style3 {color: #660000}
-->
</style>
</head>

<body>
<h1>Installing Moodle</h1>
<h2>Dont panic! <img src="http://moodle.org/pix/s/smiley.gif" /></h2>
<blockquote>
  <p>This guide explains how to install Moodle for the first time.  For some of these steps it goes into a lot of detail to try and cover the majority of possible
     web server setups, so this document may look long and complicated.  Don't panic, once you know how to do it you can install Moodle in minutes!</p>
  <p>If you have problems please read this document carefully - most common issues are answered in here.
     If you still have trouble, you can seek help from 
   <a target="_blank" href="http://moodle.org/help">Moodle Help</a></p>
  <p>Another option is to contact a <a target="_blank" href="http://moodle.com/hosting/">web hosting company</a>
     who can completely maintain Moodle for you, so that you can ignore all this and get straight into educating!
</p>
  <p>&nbsp;  </p>
  <p>Sections in this document:</p>
  <ol>
    <li><a href="#requirements">Requirements</a></li>
    <li><a href="#downloading">Download and copy files into place</a> </li>
    <li><a href="#site">Site structure</a></li>
    <li><a href="#installer">Run the installer script to create config.php</a>      <ul>
        <li><a href="#webserver">Check web server settings</a></li>
        <li><a href="#database">Creating a database</a></li>
        <li><a href="#data">Creating a data directory</a></li>
        </ul>
    </li>
    <li><a href="#admin">Go to the admin page to continue configuration</a></li>
    <li><a href="#cron">Set up cron</a></li>
    <li><a href="#course">Create a new course</a></li>
     </ol>
  <p>&nbsp;</p>
</blockquote>
<h3 class="sectionheading"><a name="requirements"></a>1. Requirements</h3>
<blockquote> 
  <p>Moodle is primarily developed in Linux using Apache, MySQL and PHP (also 
    sometimes known as the LAMP platform), but is also regularly tested with PostgreSQL 
    and on Windows XP, Mac OS X and Netware 6 operating systems</p>
  <p>The requirements for Moodle are as follows:</p>
  <ol>
    <li>Web server software. Most people use <a href="http://www.apache.org/" target="_blank">Apache</a>, 
      but Moodle should work fine under any web server that supports PHP, such 
      as IIS on Windows platforms.</li>
    <li><a href="http://www.php.net/" target="_blank">PHP</a> scripting language (version 4.1.0 
      or later). PHP 5 is supported as of Moodle 1.4. </li>
    <li>a working database server: <a href="http://www.mysql.com/" target="_blank">MySQL</a> 
      or <a href="http://www.postgresql.org/" target="_blank">PostgreSQL</a> are 
      completely supported and recommended for use with Moodle. </li>
  </ol>
  <p>Most web hosts support all of this by default. If you are signed up with 
    one of the few webhosts that does not support these features ask them why, 
    and consider taking your business elsewhere.</p>
  <p>If you want to run Moodle on your own computer and all this looks a bit daunting, 
    then please see our guide: <a href="http://moodle.org/doc/?file=installamp.html">Installing 
    Apache, MySQL and PHP</a>. It provides some step-by-step instructions to install 
    all this on most popular platforms.</p>
  <p>&nbsp;</p>
</blockquote>
<h3 class="sectionheading"><a name="downloading"></a>2. Download and copy files into place </h3>
<blockquote>
  <p>There are two ways to get Moodle, as a compressed package and via CVS. These 
    are explained in detail on the download page: <a href="http://moodle.org/download/" target="_blank">http://moodle.org/download/</a></p>
  <p>After downloading and unpacking the archive, or checking out the files via 
    CVS, you will be left with a directory called &quot;moodle&quot;, containing 
    a number of files and folders.</p>
  <p>You can either place the whole folder in your web server documents directory, 
    in which case the site will be located at <b>http://yourwebserver.com/moodle</b>, 
    or you can copy all the contents straight into the main web server documents 
    directory, in which case the site will be simply <b>http://yourwebserver.com</b>.</p>
  <p>If you are downloading Moodle to your local computer and then uploading it to your web site, it is usually better to upload the whole archive as one file, and then do the unpacking on the server. Even web hosting interfaces like Cpanel allow you to uncompress archives in the &quot;File Manager&quot;. </p>
</blockquote>
<p>&nbsp;</p>
<h3 class="sectionheading"><a name="site"></a>3. Site structure</h3>
<blockquote>
  <p>You can safely skip this section, but here is a quick summary of the contents of the Moodle folder, to help get 
    you oriented:</p>
  <blockquote>
    <table><tr>
      <td width="130" valign="top">config.php</td>
      <td valign="top">-</td>
      <td valign="top">
        contains basic settings. This file does not come with Moodle - you will create it. </td>
    </tr>
      <tr>
        <td valign="top">install.php</td>
        <td valign="top">-</td>
        <td valign="top">the script you will run to create config.php </td>
      </tr>
      <tr><td valign="top">version.php</td>
      <td valign="top">-</td>
      <td valign="top">
        defines the current version of Moodle code
      </td></tr>
      <tr><td valign="top">index.php</td>
      <td valign="top">-</td>
      <td valign="top">
        the front page of the site
      </td></tr></table>
    <ul>
      <li>admin/ - code to administrate the whole server </li>
      <li>auth/ - plugin modules to authenticate users </li>
      <li>blocks/ - plugin modules for the little side blocks on many pages</li>
      <li>calendar/ - all the code for managing and displaying calendars</li>
      <li>course/ - code to display and manage courses </li>
      <li>doc/ - help documentation for Moodle (eg this page)</li>
      <li>files/ - code to display and manage uploaded files</li>
      <li>lang/ - texts in different languages, one directory per language </li>
      <li>lib/ - libraries of core Moodle code </li>
      <li>login/ - code to handle login and account creation </li>
      <li>mod/ - all the main Moodle course modules are in here </li>
      <li>pix/ - generic site graphics</li>
      <li>theme/ - theme packs/skins to change the look of the site.</li>
      <li>user/ - code to display and manage users</li>
    </ul>
    <p>&nbsp;</p>
  </blockquote>
</blockquote>
<h3 class="sectionheading"><a name="installer"></a>4. Run the Installer script to create config.php </h3>
<blockquote>
  <p>To run the installer script (install.php), just try to access your Moodle main URL using a web browser, or access <strong>http://yourserver/install.php</strong> directly. </p>
  <p>(The Installer will try to set a session cookie. If you get a popup warning in your browser make sure you accept that cookie!) </p>
  <p>Moodle will detect that configuration is necessary and will lead you through some screens to help you create a new configuration file called <strong>config.php. </strong>At the end of the process Moodle will try and write the file into the right location, otherwise you can press a button to download it from the installer and then upload config.php into the main Moodle directory on the server. </p>
  <p>Along the way the installer will test your server environment and give you suggestions about how to fix any problems. For most common issues these suggestions should be sufficient, but if you get stuck, look below for more information about some of common things that might be holding you up. <br />
  </p>
</blockquote>
<blockquote>

<h3 class="sectionheading"><a name="webserver" id="webserver"></a>4.1 General web server settings </h3>
  <blockquote>
    <p>Firstly, make sure that your web server is set up to use index.php as a default 
      page (perhaps in addition to index.html, default.htm and so on).</p>
    <p>In Apache, this is done using a DirectoryIndex parameter in your httpd.conf 
      file. Mine usually looks like this:</p>
    <blockquote>
      <pre><strong>DirectoryIndex</strong> index.php index.html index.htm </pre>
    </blockquote>
    <p>Just make sure index.php is in the list (and preferably towards the start 
      of the list, for efficiency).</p>
    <p>Secondly, <b>if you are using Apache 2</b>, then you should turn on the <i>AcceptPathInfo</i>
       variable, which allows scripts to be passed arguments like http://server/file.php/arg1/arg2.
       This is essential to allow relative links between your resources, and also 
       provides a performance boost for people using your Moodle web site.  You can 
       turn this on by adding these lines to your httpd.conf file.</p>
    <blockquote>
      <pre><strong>AcceptPathInfo</strong> on </pre>
    </blockquote>
    <p>Thirdly, Moodle requires a number of PHP settings to be active for it to 
       work.  <b>On most servers these will already be the default settings.</b>
       However, some PHP servers (and some of the more recent PHP versions) may 
       have things set differently.  These are defined in PHP's configuration
       file (usually called php.ini):</p>
    <blockquote>
      <pre>magic_quotes_gpc = 1    (preferred but not necessary)
magic_quotes_runtime = 0    (necessary)
file_uploads = 1
session.auto_start = 0
session.bug_compat_warn = 0
  </pre>
    </blockquote>
    <p>If you don't have access to httpd.conf or php.ini on your server, or you 
      have Moodle on a server with other applications that require different settings, 
      then don't worry, you can often still OVERRIDE the default settings. 
    </p>
    <p>To do this, you need to create a file called <b>.htaccess</b> in Moodle's
       main directory that contains lines like the following.
       This only works on Apache servers and only when Overrides have been allowed in the main configuration. </p>
    <blockquote>
      <pre>
DirectoryIndex index.php index.html index.htm

&lt;IfDefine APACHE2>
     <b>AcceptPathInfo</b> on
&lt;/IfDefine>

php_flag magic_quotes_gpc 1
php_flag magic_quotes_runtime 0
php_flag file_uploads 1
php_flag session.auto_start 0
php_flag session.bug_compat_warn 0</pre>
    </blockquote>
    <p>You can also do things like define the maximum size for uploaded files:
         
</p>
    <blockquote>
      <pre>
LimitRequestBody 0
php_value upload_max_filesize 2M
php_value post_max_size 2M
     </pre>
    </blockquote>
    <p>The easiest thing to do is just copy the sample file from <strong>lib/htaccess</strong>      and edit it to suit your needs.  It contains further instructions.  For 
      example, in a Unix shell:
   </p>
    <blockquote>
      <pre>cp lib/htaccess .htaccess</pre>
    </blockquote>
  </blockquote>
<p>&nbsp;</p>
<h3 class="sectionheading"><a name="database"></a>4.2 Creating a database</h3>

  <blockquote>
    <p>You need to create an empty database (eg "<em>moodle</em>") in your database system 
      along with a special user (eg "moodleuser") that has access to that database 
      (and that database only). You could use the "root" user if you wanted to for a test server, but 
      this is not recommended for a production system: if hackers manage to discover
      the password then your whole database system would be at risk, rather than 
      just one database. </p>
    <p>If you are using a webhost, they will probably have a control panel web interface for you to create your database. </p>
    <p>The <strong>Cpanel</strong> system is  one of the most popular of these. To create a database in Cpanel, </p>
    <ol>
      <li>Click on the &quot;<strong>MySQL Databases</strong>&quot; icon.</li>
      <li>Type &quot;moodle&quot; in the database field and click &quot;<strong>Add Database</strong>&quot;.</li>
      <li> Type a username and password (not one you use elsewhere) in the respective fields and click &quot;<strong>Add User</strong>&quot;.</li>
      <li> Now use the &quot;<strong>Add User to Database</strong>&quot; button to give this new user account &quot;<strong>ALL</strong>&quot; rights to the new database.</li>
      <li>Note that the username and database names may be prefixed by your Cpanel account name. When entering this information into the Moodle installer - use the full names.</li>
    </ol>
    <p>If you have access to Unix command lines then you can do the same sort of thing by typing commands. </p>
    <p>Here are some example Unix command lines for MySQL: </p>
    <pre>
   # mysql -u root -p
   > CREATE DATABASE moodle; 
   > GRANT SELECT,INSERT,UPDATE,DELETE,CREATE,DROP,INDEX,ALTER ON moodle.* 
           TO moodleuser@localhost IDENTIFIED BY 'yourpassword'; 
   > quit 
   # mysqladmin -p reload
    </pre>
    <p>And some example command lines for PostgreSQL: </p>
    <pre>
   # su - postgres
   > psql -c "create user moodleuser createdb;" template1
   > psql -c "create database moodle;" -U moodleuser template1
   > psql -c "alter user moodleuser nocreatedb;" template1</pre>
  </blockquote>
  <p>&nbsp;</p>
  
<h3 class="sectionheading"><a name="data"></a>4.3 Creating a data directory </h3>

  <blockquote>
    <p>Moodle will also need some space on your server's hard disk to store uploaded files, such as course documents and user pictures. </p>
    <p>The Moodle installer tries hard to create this directory for you but if it fails then you will have to create a directory for this purpose manually. </p>
    <p>For security, it's best that this directory is NOT accessible directly via the web. The easiest way to do this is to simply locate it OUTSIDE the web directory, but if you must have it in the web directory then  protect it by creating a file in the data directory called .htaccess, containing this line: </p>
    <blockquote>
      <pre>deny from all<br />AllowOverride None</pre>
    </blockquote>
    <p>To make sure that Moodle can save uploaded files in this directory, check that the web server software (eg Apache) has permission to read, write and execute in  this directory. </p>
    <p>On Unix machines, this means setting the owner of the directory to be something like &quot;nobody&quot; or &quot;apache&quot;, and then giving that user read, write and execute permissions.</p>
    <p>On Cpanel systems you can use the &quot;File Manager&quot; to find the folder, click on it, then choose &quot;Change Permissions&quot;. On many shared hosting servers, you will probably need to restrict all file access to your "group" (to prevent other webhost customers from looking at or changing your files), but provide full read/write access to everyone else (which will allow the web server to access your files). </p>
    <p>Speak to your server administrator if you are having trouble setting this up securely. In particular some sites that use a PHP feature known as &quot;Safe Mode&quot; may <em>require</em> the administrator to create this directory properly for you. </p>
  </blockquote>

</blockquote>


<h3 class="sectionheading"><a name="admin"></a>5. Go to the admin page to continue configuration </h3>
<blockquote> 
  <p>Once the basic <strong>config.php</strong> has been correctly created in the previous step, trying to access the front page of your site will take you the &quot;admin&quot; page for the rest of the configuration.</p>
  <p>The first time you access this admin page, you will be presented with 
    a GPL &quot;shrinkwrap&quot; agreement with which you <strong>must</strong> agree before you 
  can continue with the setup.</p>
  <p>Now Moodle will start setting up your database and creating tables to store 
    data. Firstly, the main database tables are created. You should see a number 
    of SQL statements followed by status messages (in green or red) that look 
    like this:</p>
  <blockquote> 
    <p>CREATE TABLE course ( id int(10) unsigned NOT NULL auto_increment, category 
      int(10) unsigned NOT NULL default '0', password varchar(50) NOT NULL default 
      '', fullname varchar(254) NOT NULL default '', shortname varchar(15) NOT 
      NULL default '', summary text NOT NULL, format tinyint(4) NOT NULL default 
      '1', teacher varchar(100) NOT NULL default 'Teacher', startdate int(10) 
      unsigned NOT NULL default '0', enddate int(10) unsigned NOT NULL default 
      '0', timemodified int(10) unsigned NOT NULL default '0', PRIMARY KEY (id)) 
      TYPE=MyISAM</p>
    <p><font color="#006600">SUCCESS</font></p>
  </blockquote>
  <p>...and so on, followed by: <font color="#006600">Main databases set up 
      successfully.</font> </p>
  <blockquote>
    <p class="style3">If you don't see these, then there must have been some problem with the database 
        or the configuration settings you defined in config.php. Check that PHP isn't 
        in a restricted "Safe Mode" (commercial web hosts sometimes have safe mode 
        turned on). You can check PHP variables by creating a little file containing <strong>&lt;?php phpinfo() ?&gt;</strong> and looking at it through a browser. Check all these and 
      try this page again.</p>
  </blockquote>
  <p>Scroll down the very bottom of the page and press the &quot;Continue&quot; 
    link.</p>
  <p>You should now see a form where you can define more configuration variables 
    for your installation, such as the default language, SMTP hosts and so on. 
    Don't worry too much about getting everything right just now - you can always 
    come back and edit these later on using the admin interface. The defaults are designed to be useful and secure for most sites. Scroll down to 
    the bottom and click &quot;Save changes&quot;.</p>
  <blockquote>
    <p class="style3">If (and only if) you find yourself getting stuck on this page, unable to 
      continue, then your server probably has what I call the "buggy referrer" problem. 
      This is easy to fix: just turn off the &quot;secureforms&quot; setting, then 
      try to continue again.</p>
  </blockquote>
  <p>Next you will see more  pages that print lots of status messages as they set up all the tables required by the various Moodle module. As before, they should all be <font color="#006600">green</font>.</p>
  <p>Scroll down the very bottom of the page and press the &quot;Continue&quot; link.</p>
  <p>The next page is a form where you can define parameters for your Moodle site 
    and the front page, such as the name, format, description and so on. Fill 
    this out (you can always come back and change these later) and then press 
    &quot;Save changes&quot;.</p>
  <p>Finally, you will then be asked to create a top-level administration user 
    for future access to the admin pages. Fill out the details with your own name, 
    email etc and then click &quot;Save changes&quot;. Not all the fields are 
    required, but if you miss any important fields you'll be re-prompted for them. 
  </p>
  <blockquote> 
    <blockquote> 
      <blockquote> 
        <blockquote> 
          <blockquote> 
            <p><strong>Make sure you remember the username and password you chose 
              for the administration user account, as they will be necessary to 
              access the administration page in future.</strong></p>
          </blockquote>
        </blockquote>
      </blockquote>
    </blockquote>
    <p class="style3">(If for any reason your install is interrupted, or there is a system error 
      of some kind that prevents you from logging in using the admin account, you 
      can usually log in using the default username of &quot;<strong>admin</strong>&quot;, 
      with password &quot;<strong>admin</strong>&quot;.)</p>
  </blockquote>
  <p>Once successful, you will be returned to the home page of your new site! Note the 
    administration links that appear down the left hand side of the page (these 
    items also appear on a separate Admin page) - these items are only visible 
    to you because you are logged in as the admin user. All your further administration 
    of Moodle can now be done using this menu, such as:</p>
  <ul>
    <li>creating and deleting courses</li>
    <li>creating and editing user accounts</li>
    <li>administering teacher accounts</li>
    <li>changing site-wide settings like themes etc</li>
  </ul>
  <p>But you are not done installing yet! There is one very important thing still to do (see the next section on cron). </p>
</blockquote>
<p>&nbsp;</p>
<h3 class="sectionheading"><a name="cron"></a>6. Set up cron -- IMPORTANT! </h3>
<blockquote> 
  <p>Some of Moodle's modules require continual checks to perform tasks. For example, 
    Moodle needs to check the discussion forums so it can mail out copies of posts 
    to people who have subscribed.</p>
  <p>The script that does all this is located in the admin directory, and is called 
    cron.php. However, it can not run itself, so you need to set up a mechanism 
    where this script is run regularly (eg every five or ten minutes). This provides 
    a &quot;heartbeat&quot; so that the script can perform functions at periods 
    defined by each module. This kind of regular mechanism is known as a <strong>cron service</strong>. </p>
  <p>Note that the machine performing the cron <b>does not need to be the same 
    machine that is running Moodle</b>. For example, if you have a limited web 
    hosting service that does not have a cron service, then you can might choose to run 
    cron on another server or on your home computer. All that matters is that 
    the cron.php file is called regularly. </p>
  <p>The load of this script is not very high, so 5 minutes is usually reasonable, 
    but if you're worried about it you can reduce the time period to something 
    like 15 minutes or even 30 minutes. It's best not to make the time period 
    too long, as delaying mail-outs can slow down activity within the course.</p>
  <p>First, test that the script works by running it directly from your browser:</p>
  <blockquote> 
    <pre>http://example.com/moodle/admin/cron.php</pre>
  </blockquote>
  <p>Now, you need to set up some of way of running the script automatically and 
    regularly.</p>
  <p><b>On Windows systems</b></p>
  <blockquote>
    <p>The simplest way is to use this little package <a href="http://moodle.org/download/modules/moodle-cron-for-windows.zip" title="Click to download this package (150k)" target="_blank"><strong>moodle-cron-for-windows.zip</strong></a> which makes this whole thing very easy by installing a small Windows service. Run it and forget about it!</p>
  </blockquote>
  <p><strong>On web hosting services</strong></p>
  <blockquote>
    <p> Your web-based control panel may have a web page that allows you to set up this cron process. For example, on Cpanel system, look for a button called &quot;Cron jobs&quot;. In there you can put the same sort of Unix commands as listed below. </p>
  </blockquote>
  <h4> Using the command line on Unix </h4>
  <blockquote>
    <p>There are different command line programs you can use to call the page from the command line. Not all of them may be available on a given server.</p>
    <p>For example, you can use a Unix utility like 'wget':</p>
    <blockquote>
      <pre>wget -q -O /dev/null http://example.com/moodle/admin/cron.php</pre>
    </blockquote>
    <p>Note in this example that the output is thrown away (to /dev/null).</p>
    <p>The same thing using lynx:</p>
    <blockquote>
      <pre>lynx -dump http://example.com/moodle/admin/cron.php &gt; /dev/null</pre>
    </blockquote>
    <p>Alternatively you could use a standalone version of PHP, compiled to be run 
      on the command line. The advantage with doing this is that your web server 
      logs aren't filled with constant requests to cron.php. The disadvantage is 
      that you need to have access to a command-line version of php.</p>
    <blockquote>
      <pre>/opt/bin/php /web/moodle/admin/cron.php

    </pre>
    </blockquote>
  </blockquote>
  <h4>Using the crontab program on Unix </h4>
  <blockquote>
    <p> All that Cpanel does is provide a web interface to a Unix utility known as crontab. If you have a command line, you can set up crontab yourself using the command:</p>
    <blockquote>
      <pre>crontab -e</pre>
   </blockquote>
   <p>and then adding one of the above commands like:</p>
    <blockquote>
      <pre>*/5 * * * * wget -q -O /dev/null http://example.com/moodle/admin/cron.php</pre>
    </blockquote>
    <p>Usually, the "crontab" command will put you into the 'vi' editor. You enter 
     "insert mode" by pressing "i", then type in the line as above, then exit insert mode by 
         pressing ESC.  You save and exit by typing ":wq", or quit without saving using ":q!" (without the quotes).</p>
  </blockquote>
  <p>&nbsp;</p>
</blockquote>
<h3 class="sectionheading"><a name="course"></a>7. Create a new course</h3>
<blockquote>
  <p>Now that Moodle is running properly, you can try creating a new course to play with. </p>
  <p>Select &quot;Create a new course&quot; from the Admin page (or the admin 
    links on the home page).</p>
  <p>Fill out the form, paying special attention to the course format. You don't 
    have to worry about the details too much at this stage, as everything can 
    be changed later by the teacher. Note that the yellow help icons are everywhere to provide contextual help on any aspect. </p>
  <p>Press &quot;Save changes&quot;, and you will be taken to a new form where 
    you can assign teachers to the course. You can only add existing user accounts 
    from this form - if you want to create a new teacher account then either ask 
    the teacher to create one for themselves (see the login page), or create one 
    for them using the &quot;Add a new user&quot; on the Admin page.</p>
  <p>Once done, the course is ready to customise, and is accessible via the &quot;Courses&quot; 
    link on the home page.</p>
  <p>See the &quot;<a href="./?file=teacher.html">Teacher Manual</a>&quot; for more details 
    on course-building.</p>
  <p>&nbsp;</p>
  <p align="center"><strong>Happy exploring and happy Moodling!</strong></p>
  <p align="center"><strong>If you like Moodle, please consider <a href="http://moodle.org/donations/" target="_blank">donating</a> to help us cover our costs! </strong></p>
</blockquote>
<p>&nbsp;</p>
<p align="center"><font size="1"><a href="." target="_top">Moodle Documentation</a></font></p>
<p align="center"><font size="1">Version: $Id$</font></p>
</body>
